﻿using System;
using System.Diagnostics;
using System.IO;

/**
 *  This class will convert PDF files to JPG images using Ghostscript
 */
public class PDF2Image
{
	
		/**
		 * output directory for jpg files
		 **/
	    public string outputDirectory="c:\\";
	
		/**
		 * bin directory of ghostscript
		 */
		public string ghostscriptDir="c:\\Program Files\\gs\\gs8.00\\bin\\";
	
		/**
		 * output file prefix
		 */
		 public string outputprefix="out";
	
		/**
		 * resolution (dpi) used for creating the jpeg file (see ghostscript documentation). You can use for example 140 for higher resolution
		 */
		 public int resolution=0;
	
		/**
		 * convert a pdf file to JPEG
		 */
		public String[] toJPEG(string inputPDFFile) {
		
		ProcessStartInfo startInfo = new ProcessStartInfo(ghostscriptDir+"gswin32c.exe");
		startInfo.UseShellExecute = false;

		// use -r140 to increase resolution 
		string resolutionStr="";
		if (resolution>0) resolutionStr="-r"+resolution;
		startInfo.Arguments="-sDEVICE=jpeg -sOutputFile#"+outputDirectory+outputprefix+"%d.jpg "+resolutionStr+" -dNOPAUSE -dBATCH "+inputPDFFile;
		startInfo.WindowStyle=	ProcessWindowStyle.Normal;
		
		startInfo.WorkingDirectory=ghostscriptDir;
		

		Process p=Process.Start(startInfo);
		p.WaitForExit();	
	
		
		int files=0;
		for (int i=1;i<100;i++)
			if (File.Exists(outputDirectory+outputprefix + i + ".jpg")) files++;
		
		string[] iFiles=new string[files];
		for (int i=1;i<=files;i++) iFiles[i-1]=outputDirectory+outputprefix + i + ".jpg";
			
		return iFiles;

		}
		
	
	
}




